-- Copyright 2012 3d-io
-- 3D-IO Games & Video Production GmbH | Albrechtstrasse 46 | 65185 Wiesbaden | GERMANY
-- Contact: info@3d-io.com
-- Author: Friedrich Hanisch

macroScript Unwrelper
	category:"3d-io"
	toolTip:"Unwrella Seam Helper"
	icon:#("Unwrella2Helper", 1)
(
	fn clear_seams =
	(
		undo on
		(
			for obj in (selection as array) do
			(
				for umod in obj.modifiers where classof umod == unwrap_uvw do
				(
					setCommandPanelTaskMode #modify
					modPanel.setCurrentObject umod
					umod.setTVSubObjectMode 3
					umod.mappingMode 1
					local tempfaces = umod.getSelectedFaces()
					umod.selectFaces #{1..umod.numberPolygons()}
					completeRedraw()
					umod.mappingReset()
					umod.mappingMode 0
					umod.selectFaces tempfaces
				)
				modPanel.setCurrentObject obj
			)
		)
	)
	
	fn use_pelt_seams =
	(
		undo on
		(
			for obj in (selection as array) do
			(
				for umod in obj.modifiers where classof umod == unwrap_uvw do
				(
					setCommandPanelTaskMode #modify
					modPanel.setCurrentObject umod
					umod.setTVSubObjectMode 2
					umod.setSelectedGeomEdges (umod.getPeltSelectedSeams())
					umod.syncTVSelection()
					umod.edit()
					umod.setTVSubObjectMode 2
					umod.breakselected()
					umod.setPeltSelectedSeams #{}
				)
				modPanel.setCurrentObject obj
			)
		)
	)

	fn add_unwrella_modifier =
	(
		if unwrella != undefined then
		(
			undo on
			(
				for obj in (selection as array) do
				(
					if validModifier obj unwrella then
					(
						unwr = unwrella()
						addmodifier obj unwr
						unwr.keep_seams = true
					)
				)
			)
		)
		else
		(
			messagebox "Unwrella modifier not found. You can get Unwrella at http://www.unwrella.com"
		)
	)

	rollout unwrella_helper "Unwrella Seam Helper"
	(
		button bt_use_pelt_seams "Create Seams" width:125 height:40 pos:[5, 5]
		button bt_add_unwrella "Add Unwrella Modifier" width:125 height:20 pos:[5, 50]
		button bt_clear_seams "Remove All Seams" width:125 height:20 pos:[5, 75]
		label id "Seam Helper v1.2"
		label copyright "(c) 2012 3d-io"

		on bt_use_pelt_seams pressed do use_pelt_seams()
		on bt_add_unwrella pressed do add_unwrella_modifier()
		on bt_clear_seams pressed do clear_seams()
	)
	
	createDialog unwrella_helper 135 140
)

